#include "Header.h"
#include <iostream>
#include <locale>
#include <algorithm>
#include <fstream>
#include <stdlib.h>
#include <vector>
#include <iterator>
#include <iomanip>
#include <math.h>

using namespace std;

class Functor
{
	int num;
public:
	Functor(int c = 0) :num(c) {}
	int operator()(int &a)
	{
		return rand() % 100 - 51;
	}
};

class Func
{
	int min;
public:
	Func(int c = 0) :min(c) {}
	int operator()(int& a)
	{
		return min * a;
	}
};

void CreateData()
{
	srand(time(NULL));
	fstream fout;
	fout.open("NewFile.txt");
	if (fout.is_open())
	{
		cout << " Файл успешно открыт!" << endl;
	}
	else throw ("Ошибка открытия файла");
	for (unsigned i = 0; i < 100; ++i)
	{
		fout << rand() % 100 - 51 << setw(4);
	}
	fout.close();
}
 
class Random 
{
	int num;
public:
	Random(int l) : num(l) {}
	int operator() () { return rand() % 100 - 51; }
};


void createData()
{
	srand(time(NULL));
	ofstream fout;
	fout.open("NewFile.txt");
	if (fout.is_open())
	{
		cout << " Файл успешно открыт!" << endl;
	}
	else throw ("Ошибка открытия файла");
	vector <int> vect;
	vect.resize(100);
	Random r(0);
	generate(vect.begin(), vect.end(), r);
	copy(vect.begin(), vect.end(), ostream_iterator<int>(fout, " "));
	cout << "\nСодержимое последовательного контейнера\n";
	for (auto iv : vect) {
		cout << iv << setw(5);
		}
	copy(vect.begin(), vect.end(), ostream_iterator<int> (fout, " "));
	fout.close();
}


template <typename  Container >
 void LoadData(Container &cont)
{
	 ifstream fin;
	 fin.open("NewFile.txt");
	 if (fin.is_open())
	 {
		 cout << " Файл успешно открыт!" << endl;
	 }
	 else throw ("Ошибка открытия файла");
	 int num;
	 while (!fin.eof())
	 {
		 fin >> num;
		 cont.push_back(num);
	 }
	 cont.pop_back;
	 fin.close();
}

 template < typename Container >
 void loadData(Container& cont)
 {
	 ifstream fin;
	 fin.open("NewFile.txt");
	 if (fin.is_open())
	 {
		 cout << " Файл успешно открыт!" << endl;
	 }
	 else throw ("Ошибка открытия файла");
	 istream_iterator<int> iterstart(fin);
	 istream_iterator<int> iterend;
	 copy(iterstart, iterend, back_inserter(cont));
 }

 template<typename Container>
 void modify_for_each(Container& cont)
 {
	 auto result = min_element(cont.begin(), cont.end());
	 cout << " Минимальное число = " << *result << endl;
	 int min = *result;
	 for_each(cont.begin(), cont.end(), [min](int& a) {
		 a *= min;
		 }
	 );
 }

 template<typename Iterator>
 void modify_iterator(Iterator begin, Iterator end)
 {
	 auto result = min_element(begin, end);
	 cout << " Минимальное число = " << *result << endl;
	 int min = *result;
	 for_each(begin, end, [min](int& a) {
		 a *= min;
		 }
	 );
 }

 template<typename Container>
 void modify_container(Container& cont)
 {
	 unsigned sum = 0;
	 double srd = 0;
	 for_each(begin, end, [&sum](int a) {
		 abs(a+= sum);
		 }
	 );
	 srd = sum / cont.size;
	 cont.push_back(sum);
	 cont.push_back(srd);

 }

 template <typename Container>
 void modify_transform(Container& cont)
 {
	 auto result = min_element(cont.begin(), cont.end());
	 int min = *result;
	 ofstream fout;
	 ostream_iterator<int> iterstart(fout, " ");
	 Func f(min);
	 fout.open("Result.txt");
	 if (fout.is_open())
	 {
		 cout << " Файл успешно открыт!" << endl;
	 }
	 else throw ("Ошибка открытия файла");
	 transform(cont.begin(), cont.end(), iterstart, f);
 }

 

 template<typename Container>
 void output_result(Container& cont)
 {
	 auto iter = cont.begin();
	 ofstream fout;
	 fout.open("NewFile.txt");
	 if (fout.is_open())
	 {
		 cout << " Файл успешно открыт!" << endl;
	 }
	 else throw ("Ошибка открытия файла");
	 while (iter!=iter.end())
	 {
		 fout << *iter;
		 ++iter;
	 }
 }

 template<typename Container>
 void OutputResult(Container& cont)
 {
	 ofstream fout;
	 fout.open("NewFile.txt");
	 if (fout.is_open())
	 {
		 cout << " Файл успешно открыт!" << endl;
	 }
	 else throw ("Ошибка открытия файла");
	 ostream_iterator<int> iter(fout, " ");
	 copy(cont.begin(), cont.end(), iter);
 }