#include "Head.h"
#include <iostream>
#include <locale>
#include <vector>
#include <list>
#include <deque>
#include "FileException.h"

using namespace std;

int main()
{
	try {
		setlocale(0, "russian");
		vector<int> vec ;
		vec.reserve(100);
		cout << " ВЕКТОР " << endl << endl;
		cout << "Создание файла с использованием файловых потоков " << endl;
		CreateData();
		cout << endl << "Создание файла с использованием потоковых итераторов " << endl;
		createData();
		cout << endl << "Загрузка данных в последовательный контейнер с использованием файловых потоков " << endl;
		LoadData(vec);
		cout << endl << "Загрузка данных в последовательный контейнер с использованием потоковых итераторов " << endl;
		loadData(vec);
		cout << endl << "Шаблонная функция, принимающая последовательный контейнер данного типа" << endl;
		modify_container(vec);
		cout << endl << "Функция, использующая алгоритм for_each()" << endl;
		modify_for_each(vec);
		cout << endl << "Функция, использующая алгоритм transform() и потоковые итераторы " << endl;
		modify_transform(vec);
		cout << endl << "Функция, принимающая аргументы-итераторы " << endl;
		modify_iterator(vec.begin(), vec.end());
		cout << endl << "Функция, выгружающая данные с использованием файловых потоков" << endl;
		output_result(vec);
		cout << endl << "Функция, использующая алгоритм copy для вывода контейнера в файл с использованием потоковых итераторов" << endl;
		OutputResult(vec);

		list<int> list;
		cout <<endl << " СПИСОК " << endl << endl;
		cout << "Создание файла с использованием файловых потоков " << endl;
		CreateData();
		cout << endl << "Создание файла с использованием потоковых итераторов " << endl;
		createData();
		cout << endl << "Загрузка данных в последовательный контейнер с использованием файловых потоков " << endl;
		LoadData(list);
		cout << endl << "Загрузка данных в последовательный контейнер с использованием потоковых итераторов " << endl;
		loadData(list);
		cout << endl << "Шаблонная функция, принимающая последовательный контейнер данного типа" << endl;
		modify_container(list);
		cout << endl << "Функция, использующая алгоритм for_each()" << endl;
		modify_for_each(list);
		cout << endl << "Функция, использующая алгоритм transform() и потоковые итераторы " << endl;
		modify_transform(list);
		cout << endl << "Функция, принимающая аргументы-итераторы " << endl;
		modify_iterator(list.begin(), list.end());
		cout << endl << "Функция, выгружающая данные с использованием файловых потоков" << endl;
		output_result(list);
		cout << endl << "Функция, использующая алгоритм copy для вывода контейнера в файл с использованием потоковых итераторов" << endl;
		OutputResult(list);

		deque<int> deq;
		cout << endl << " ОЧЕРЕДЬ " << endl << endl;
		cout << "Создание файла с использованием файловых потоков " << endl;
		CreateData();
		cout << endl << "Создание файла с использованием потоковых итераторов " << endl;
		createData();
		cout << endl << "Загрузка данных в последовательный контейнер с использованием файловых потоков " << endl;
		LoadData(deq);
		cout << endl << "Загрузка данных в последовательный контейнер с использованием потоковых итераторов " << endl;
		loadData(deq);
		cout << endl << "Шаблонная функция, принимающая последовательный контейнер данного типа" << endl;
		modify_container(deq);
		cout << endl << "Функция, использующая алгоритм for_each()" << endl;
		modify_for_each(deq);
		cout << endl << "Функция, использующая алгоритм transform() и потоковые итераторы " << endl;
		modify_transform(deq);
		cout << endl << "Функция, принимающая аргументы-итераторы " << endl;
		modify_iterator(deq.begin(), deq.end());
		cout << endl << "Функция, выгружающая данные с использованием файловых потоков" << endl;
		output_result(deq);
		cout << endl << "Функция, использующая алгоритм copy для вывода контейнера в файл с использованием потоковых итераторов" << endl;
		OutputResult(deq);
		
	}
	catch (exception& ex)
	{
		cout << ex.what() << endl;
	}
	catch (...)
	{
		cout << " Неизвестная ошибка" << endl;
	}
	system("pause");
	return 0;
}
